require net
require message

##     http://www.i-hacked.com/content/view/108/94/
##     http://www.rokulabs.com/community/developer.php
## 
##     Functional Specification Roku Control Protocol
## 	(Port 5555)
##     Shell-Interface
## 	(Port 4444, einfache TCP-Verbindung)

## static text

default_sbmessage() { default_short_message; }
encode_sbmessage() { encode_sb "$@"; }

sbmessage() {
    __rawmsg sbmessage --port=4444 -t dummy "$@"
}
    
__rawmsg_sbmessage() {
    {
	local msg=$(encode_sbmessage "$*")
	_sb_init
	echo "text c c \"$msg\""
	sleep ${SB_TIMEOUT:-10}
	echo "quit"
    } | _sb_sketch 
}

## multi-line static text

default_sbxmessage() { default_sbmessage; }
encode_sbxmessage() { encode_sb "$@"; }

sbxmessage() {
    __rawmsg sbxmessage --port=4444 -t dummy "$@"
}

__rawmsg_sbxmessage() {
    {
	local msg lno=0
	_sb_init
	echo "$*" | while IFS= read -r line; do
	    msg=$(encode_sbxmessage "$line")
	    echo "text c $lno \"$msg\""
	    let lno++
	done
	sleep ${SB_TIMEOUT:-10}
	echo "quit"
    } | _sb_sketch 
}

## scrolling text

default_sbmarquee() { default_message; }
encode_sbmarquee() { encode_sb "$@"; }

sbmarquee() {
    __rawmsg sbmarquee --port=4444 -t dummy "$@"
}
__rawmsg_sbmarquee() {
    {
	local msg=$(encode_sbmessage "$*")
	local n=${SB_TIMES:-3}
	local timeout=$((1000 * $(_sb_timeout "$msg")))
	local final_timeout=$((1000 * $(SB_OVERLAP=-5 _sb_timeout "$msg")))
	_sb_init
	while ? "n > 0"; do
	    echo "marquee -start \"$msg\""
	    let n--
	    usleep $((n == 0 ? final_timeout : timeout))
	done
	echo "quit"
    } | _sb_sketch
}

## miwu (IPPF):
## Daraus entsteht dann beim Marquee das Problem, dass man den Timeout fr
## lngere Texte hher setzen mu als fr krzere. Der von Dir erstmal gewhlte
## Wert von 5 wrde so fr ca. 28-30 Zeichen reichen, dann beginnt schon das
## "neue Marquee", whrend das "neue Marquee" bei einem zu kurzen Timeout das
## vorherige Marquee gnadenlos abschneidet. Ein Timeout-Wert von 7 bedeutet bei
## Deiner Probe-Textlnge [23], dass der neue Durchlauf genau dann beginnt, wenn der
## alte gerade das Display verlassen hat. Jeder Buchstabe wird also ca. 5
## Sekunden lang durchlaufend auf dem Display dargestellt.

## Schn finde ich, dass es bei Marquee funktioniert, den Textanfang des 2.
## Marquee von rechts reinlaufen zu lassen, whrend das Ende des 1. Marquees
## noch rausluft. Das Display mu also nicht zwischen den Marquees gecleart
## werden (machst Du ja auch nur vor dem 1.).

## Fehlt nur noch die Anzahlt der darstellbaren Zeichen. In der Schriftart
## Nummer 2 (Vertiakal displayfllend) werden mit bei folgendem Befehl 35
## Zeichen dargestellt.
## 
## sketch -c text c c 0123456789012345678901234567890123456789
## 
## zeigt also
## 
## 01234567890123456789012345678901234
## 
## an.

_sb_timeout() {
    local msg=$1
    local len=${#msg}

    ## about how many chars fit into the display
    local visible=${SB_VISIBLE:-35}

    ## start a new run when so many chars are left
    local overlap=${SB_OVERLAP:-10}

    ## how fast are the characters moving
    local speed=${SB_SPEED:-7200} ## milli-chars per second :o)
    local time
    let "time = (len + visible - overlap) * 1000000 / speed" ## milliseconds
    echo $((time < 0 ? 0 : time))
}

## common definitions

## We do not use 'echo "$1"' because we need a single-line message (whitespace
## is collapsed, which could be undesired)
encode_sb() {
    case $1 in
	*[\"\\]*) echo $1 | sed -e 's/["\]/\\&/g' ;;
	*) echo $1 ;;
    esac
}

## helpers

_sb_sketch() {
    {
	echo "sketch"
	cat
    } | _connect
}
_sb_init() {
    echo "font ${SB_FONT:-2}"
    echo "encoding latin1"
    echo "clear"
}
